%{!?python_sitearch: %global python_sitearch %(/usr/bin/python2.6 -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%global with_gcj %{!?_without_gcj:1}%{?_without_gcj:0}

Distribution:   CCux
Packager:	Karsten Brockmann <arcam@ccux-linux.de>

Name:		portmidi
Version:	217
Release:	1
Provides:	%{name}
License:	GNU/GPL 
URL:		http://sourceforge.net/apps/trac/portmedia/wiki/portmidi
Group:		Sound
Source0:	portmidi-src-217.zip
Source200:	pmdefaults.desktop
Patch0:		portmidi-cmake.patch	
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildArch:	i686

Summary:	Portable API for real-time MIDI I/O 

#Automatically resolved build dependencies
BuildRequires: alsa-lib-devel
BuildRequires: glibc-devel
BuildRequires: java-1.5.0-gcj
BuildRequires: java-1.5.0-gcj-devel
BuildRequires: java-1.5.0-gcj-src
BuildRequires: java-1.6.0-openjdk
BuildRequires: java-1.6.0-openjdk-devel

BuildRequires: libgcc
BuildRequires: libgcj-devel
BuildRequires: python26-devel
BuildRequires: zlib-devel

%description
PortMedia is a set of simple clean APIs and cross-platform library
implementations for music and other media. PortMidi sub-project provides a
real-time MIDI input/output library. This package contains the PortMidi
libraries.

%package devel
Summary:	%{name} development headers.
Group:		%{group}            
Requires:	%{name} = %{version}-%{release}

%description devel
Header and include files for developing applications with %{name}.

%package -n python-%{name}
Summary:        Python wrapper for %{name}
Group:          System Environment/Libraries
Requires:       %{name} = %{version}-%{release}

%description -n python-%{name}
PortMedia is a set of simple clean APIs and cross-platform library
implementations for music and other media. PortMidi sub-project provides a
real-time MIDI input/output library. This package contains the python
bindings of PortMidi libraries. It can send and receive MIDI data in
real-time from Python.

%package tools
Summary:        Tools to configure and use %{name}
Group:          Applications/Multimedia
Requires:       hicolor-icon-theme
Requires:       %{name} = %{version}-%{release}

%description tools
PortMedia is a set of simple clean APIs and cross-platform library
implementations for music and other media. PortMidi sub-project provides a
real-time MIDI input/output library. This package contains the PortMidi
configuration utility "pmdefaults" and some test applications.

%post
ldconfig

%postun
ldconfig

%prep
%setup -qn %{name}
%patch0 -p1

# ewwww... binaries
rm -f portmidi_cdt.zip */*.exe */*/*.exe

# Fix permissons and encoding issues:
find . -name "*.c" -exec chmod -x {} \;
find . -name "*.h" -exec chmod -x {} \;
for i in *.txt */*.txt */*/*.txt ; do
   chmod -x $i
   sed 's|\r||' $i > $i.tmp
   touch -r $i $i.tmp
   mv -f $i.tmp $i
done

# Our jni library location is different
sed -i 's|loadLibrary.*|load("%{_libdir}/%{name}/libpmjni.so");|' \
   pm_java/jportmidi/JPortMidiApi.java

# Add shebang, lib and class path
sed -i -e 's|^java|#!/bin/sh\njava \\\
   -Djava.library.path=%{_libdir}/%{name}/|' \
   -e 's|/usr/share/java/|%{_libdir}/%{name}/|' \
   pm_java/pmdefaults/pmdefaults

%build
export JAVA_HOME=%{java_home}
%cmake -DCMAKE_SKIP_BUILD_RPATH=1 -DCMAKE_CACHEFILE_DIR=%{_builddir}/%{name}/build -DVERSION=%{version} .
make %{?_smp_flags}

# Build python modules
PYTHON_VER=$(/usr/bin/python2.6 -c "from sys import version; print (version[:3])")
PYTHON_INC=$(/usr/bin/python2.6 -c "from distutils.sysconfig import get_python_inc; print get_python_inc()")
pushd pm_python/pyportmidi
   gcc %{optflags} -pthread -fPIC -c -o _pyportmidi.o -I../../pm_common \
       -I../../porttime -I$PYTHON_INC _pyportmidi.c
   gcc -shared -o _pyportmidi.so _pyportmidi.o -lportmidi -lpython$PYTHON_VER \
       -L../../build/Release
popd


%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}

# Install the test applications:
install -d %{buildroot}%{_libdir}/%{name}
for app in latency midiclock midithread midithru mm qtest sysex test; do
   install -m 0755 build/Release/$app %{buildroot}%{_libdir}/%{name}/
done

# Our jni library location is different
mv %{buildroot}%{_libdir}/libpmjni.so \
   %{buildroot}%{_libdir}/%{name}/
mv %{buildroot}%{_javadir}/pmdefaults.jar \
   %{buildroot}%{_libdir}/%{name}/

# pmdefaults icon
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/
install -pm 644 pm_java/pmdefaults/pmdefaults-icon.png \
   %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/

# desktop file
mkdir -p %{buildroot}%{_desktopdir}/
desktop-file-install \
   --dir=%{buildroot}%{_desktopdir} \
   %{SOURCE200}

# Why don't they install this header file?
install -pm 644 pm_common/pmutil.h %{buildroot}%{_includedir}/

# Install python modules
mkdir -p %{buildroot}%{python_sitearch}/pyportmidi
pushd pm_python/pyportmidi
   install -pm 755 _pyportmidi.so %{buildroot}%{python_sitearch}/pyportmidi/
   install -pm 644 *.py %{buildroot}%{python_sitearch}/pyportmidi/
popd

# we don't want to provide private python extension libs
%{?filter_setup:
%filter_provides_in %{python_sitearch}/.*\.so$
%filter_setup
}

# Remove duplicate library
rm -f %{buildroot}%{_libdir}/libportmidi_s.so

# AOT bits
%if %{with_gcj}
   %{_bindir}/aot-compile-rpm
%endif

find %{buildroot} -type f \
-exec /usr/bin/strip --strip-debug '{}' ';' 

%files
%defattr(-,root,root,-)
%doc CHANGELOG.txt license.txt
%{_libdir}/libportmidi.so.*

%files tools
%defattr(-,root,root,-)
%doc pm_java/pmdefaults/README.txt pm_cl/*
%{_libdir}/portmidi/
%{_bindir}/pmdefaults
%{_datadir}/icons/hicolor/128x128/apps/pmdefaults-icon.png
%{_applications}/pmdefaults.desktop
%if %{with_gcj}
%{_libdir}/gcj/portmidi/
%endif

%files -n python-%{name}
%defattr(-,root,root,-)
%doc pm_python/README_PYTHON.txt
%{python_sitearch}/pyportmidi/

%files devel
%defattr(-,root,root,-)
%doc README.txt
%{_includedir}/pmutil.h
%{_includedir}/portmidi.h
%{_includedir}/porttime.h
%{_libdir}/libportmidi.so

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Sun Oct 17 2010 Karsten Brockmann <arcam@ccux-linux.de> 217-1
- initial CCux package release
